%define name compiz
%define version 0.6.2
%define rel 2
%define git 0

%define major 0
%define libname %mklibname %{name} %major
%define libname_devel %mklibname -d %{name}


%if  %{git}
%define srcname %{name}-%{git}
%define distname %{name}
%define release %mkrel 0.%{git}.%{rel}
%else
%define srcname %{name}-%{version}
%define distname %{name}-%{version}
%define release %mkrel %{rel}
%endif

Name: %name
Version: %version
Release: %release
Summary: OpenGL composite manager for Xgl and AIGLX
Group: System/X11
URL: http://www.go-compiz.org/
Source: http://xorg.freedesktop.org/archive/individual/app/%{srcname}.tar.gz 
Source1: compiz.defaults
Source2: compiz-window-decorator
# Patches for AIGLX
# Thanks Kristian Høgsberg
# Patch1 updated by Johannes (Hanno) B�ck to automatically detect AIGLX
# http://svn.hboeck.de/xgl-overlay/x11-wm/compiz/files/compiz-tfp
Patch1: 0001-Also-check-for-tfp-in-server-extensions-rediff.txt
Patch2:	compiz-0.3.6-kde-mem-leak.patch
# Patches for Mandriva defaults
Patch3: compiz-default-plugins.patch
Patch4: compiz-mandriva-top.patch
Patch6: compiz-decoration-command.patch
Patch7: compiz-window-decorator.patch
Patch8: compiz-fix-kde-screensaver.patch

License: GPL
BuildRoot: %{_tmppath}/%{name}-root

BuildRequires: libx11-devel >= 1.0.0
BuildRequires: x11-util-macros >= 1.0.1
BuildRequires: x11-proto-devel
BuildRequires: librsvg-devel
BuildRequires: libsvg-cairo-devel
BuildRequires: libpng-devel
BuildRequires: GL-devel
BuildRequires: libwnck-devel
BuildRequires: metacity-devel
BuildRequires: libgnome-window-settings-devel
BuildRequires: libgnome-desktop-2-devel
BuildRequires: libxcomposite-devel
BuildRequires: libxdamage-devel
BuildRequires: intltool
BuildRequires: automake
BuildRequires: libdbus-qt-1-devel
BuildRequires: kdebase-devel
BuildRequires: fuse-devel
BuildRequires: libxslt-devel
BuildRequires: libxslt-proc
Requires(post): GConf2
Requires(preun): GConf2
Requires: %{libname} = %{version}-%{release}
Requires: compositing-wm-common
Provides: compositing-wm
Requires: compiz-decorator
Obsoletes: beryl-core

%description
OpenGL composite manager for Xgl and AIGLX.

#----------------------------------------------------------------------------

%package decorator-gtk
Summary: GTK window decorator for compiz
Group: System/X11
Provides: compiz-decorator
Conflicts: %{name} < 0.3.6-4mdv2007.1
Requires:  %{name} = %{version}-%{release}
Obsoletes: heliodor

%description decorator-gtk
This package provides a GTK window decorator for the compiz OpenGL
compositing manager.

#----------------------------------------------------------------------------

%package decorator-kde
Summary: KDE window decorator for compiz
Group: System/X11
Provides: compiz-decorator
Conflicts: %{name} < 0.3.6-4mdv2007.1
Requires:  %{name} = %{version}-%{release}
Obsoletes: aquamarine

%description decorator-kde
This package provides a KDE window decorator for the compiz OpenGL
compositing manager.

#----------------------------------------------------------------------------

%package -n %libname
Summary: Shared libraries for compiz
Group: System/X11
Conflicts: %{name} < 0.5.1
Obsoletes: %mklibname beryl-core 0

%description -n %libname
Shared libraries for compiz

#----------------------------------------------------------------------------

%package -n %libname_devel
Summary: Development files for compiz
Group: Development/X11
Provides:  %{name}-devel = %{version}-%{release}
Obsoletes: %{name}-devel
Requires: %{libname} = %{version}-%{release}
Requires: png-devel
Requires: libxcomposite-devel
Requires: libxdamage-devel
Requires: libxfixes-devel
Requires: libxrandr-devel
Requires: libxinerama-devel
Requires: libice-devel
Requires: libsm-devel
Requires: startup-notification-devel
Requires: GL-devel
Requires: libxslt-devel
Requires: libxslt-proc
Requires: glib2-devel

Obsoletes: %mklibname -d beryl-core 0

%description -n %libname_devel
Development files for compiz

#----------------------------------------------------------------------------

%prep
%setup -q -n %{distname}
%patch1 -p1 -b .tfp_server_ext
%patch2 -p1 -b .fix_kde_windows_decoration_mem_leak
%patch3 -p1 -b .defplug
%patch4 -p1 -b .top
%patch6 -p1 -b .decorator_command
%patch7 -p1 -b .compiz_decorator
%patch8 -p1 -b .kde_screensaver

%build
%if %{git}
  # This is a CVS snapshot, so we need to generate makefiles.
  sh autogen.sh -V
%endif
%if %{mdkversion} < 200800
  # (colin) This seems to be needed on 2007.1 but breaks things on 2008+
  autoreconf
%endif
perl -pi -e "s|(QTDIR/)lib|\1%{_lib}|" configure
%configure2_5x 
%make

%install
rm -rf %{buildroot}
%makeinstall_std
install -m755 %{SOURCE2} %{buildroot}%{_bindir}/%{name}-window-decorator
install -D -m644 %{SOURCE1} %{buildroot}%{_datadir}/compositing-wm/%{name}.defaults
%find_lang %{name}

%define schemas compiz-annotate compiz-blur compiz-clone compiz-core compiz-cube compiz-dbus compiz-decoration compiz-fade compiz-fs compiz-gconf compiz-glib compiz-ini compiz-inotify compiz-minimize compiz-move compiz-place compiz-plane compiz-png compiz-regex compiz-resize compiz-rotate compiz-scale compiz-screenshot compiz-svg compiz-switcher compiz-video compiz-water compiz-wobbly compiz-zoom

%post
%post_install_gconf_schemas %{schemas}

%preun
%preun_uninstall_gconf_schemas %{schemas}

%triggerpostun -- beryl-core

if [ -w %{_sysconfdir}/sysconfig/compositing-wm ]; then
  sed -i 's/COMPOSITING_WM=beryl/COMPOSITING_WM=compiz-fusion/' \
   %{_sysconfdir}/sysconfig/compositing-wm
fi

%post decorator-gtk
%post_install_gconf_schemas gwd

%preun decorator-gtk
%preun_uninstall_gconf_schemas gwd

%clean
rm -rf %{buildroot}

#----------------------------------------------------------------------------

%files -f %{name}.lang
%defattr(-,root,root)
%{_bindir}/%{name}
%{_bindir}/%{name}-window-decorator
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.so
%{_libdir}/%{name}/*.la
%{_libdir}/%{name}/*.a
%{_libdir}/window-manager-settings/lib%{name}.*
%(for schema in %schemas; do
   echo "%{_sysconfdir}/gconf/schemas/$schema.schemas"
  done)
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.png
%{_datadir}/%{name}/*.xml
%{_datadir}/%{name}/*.xslt
%{_datadir}/gnome/wm-properties/%{name}.desktop
%{_datadir}/compositing-wm/%{name}.defaults

%files decorator-gtk
%defattr(-,root,root)
%{_bindir}/gtk-window-decorator
%{_sysconfdir}/gconf/schemas/gwd.schemas
%if %{mdkversion} > 200710
%{_datadir}/gnome-control-center/keybindings/50-%{name}-key.xml
%{_datadir}/gnome-control-center/keybindings/50-%{name}-desktop-key.xml
%endif

%files decorator-kde
%defattr(-,root,root)
%{_bindir}/kde-window-decorator

%files -n %libname
%defattr(-,root,root)
%{_libdir}/libdecoration.so.*

%files -n %libname_devel
%defattr(-,root,root)
%{_includedir}/%{name}/%{name}.h
%{_includedir}/%{name}/cube.h
%{_includedir}/%{name}/decoration.h
%{_includedir}/%{name}/scale.h
%{_libdir}/libdecoration.a
%{_libdir}/libdecoration.la
%{_libdir}/libdecoration.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/%{name}-cube.pc
%{_libdir}/pkgconfig/%{name}-gconf.pc
%{_libdir}/pkgconfig/%{name}-scale.pc
%{_libdir}/pkgconfig/libdecoration.pc


%changelog
* Wed Oct 24 2007 Colin Guthrie <cguthrie@mandriva.org> 0.6.2-2mdv2008.1
+ Revision: 101678
- Potentially fix #29780 (screensaver locking up) by disabling decorations for windows where name=kdesktop_lock
- Do not update gconf schemas as they are autogenerated

* Fri Oct 19 2007 Colin Guthrie <cguthrie@mandriva.org> 0.6.2-1mdv2008.1
+ Revision: 100095
- New upstream version (0.6.2)

* Fri Oct 05 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-10mdv2008.0
+ Revision: 95542
- Make compiz start the window decorator on init again (this wont work with session saving but such is life)

* Wed Oct 03 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-9mdv2008.0
+ Revision: 95091
- Make the decorator command patch better

* Wed Oct 03 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-8mdv2008.0
+ Revision: 95025
- Fix #29769 by using compiz to start the decorator
- Fix a compiz bug that prevented decorator from being run if option value was not changed (e.g. on startup)

* Fri Sep 28 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-7mdv2008.0
+ Revision: 93465
- Automatically change config to load compiz-fusion when upgrading from beryl

* Tue Sep 25 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-6mdv2008.0
+ Revision: 92758
- Fixes kde-window-decorators and maximized windows (#32215)
- Use autoreconf on 2007.1 build

* Tue Sep 04 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-5mdv2008.0
+ Revision: 79532
- Drop minimize-unminimize patch as this appears to be now be solved via other means.
- Reorganise patch order.
- More minor changes to make for smooth backporting
- Run aclocal and friends (mainly for 2007.1)

  + Olivier Blin <oblin@mandriva.com>
    - remove white borders fix, artefact is gone with recent Mesa
    - drop NET_WM_CM patch, it breaks --replace (thanks to ocilent1)
      (better fixed in upstream CM selection support, commits
       d9621f6fced9feda1c154c745be5c502f8a14568 and
       65cac43f1bdc8e999991f9022ab079fb7fa4b11f)

* Sun Aug 12 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-3mdv2008.0
+ Revision: 62118
- Add build dep on librsvg-devel for svg plugin.

* Tue Aug 07 2007 Olivier Blin <oblin@mandriva.com> 0.5.2-2mdv2008.0
+ Revision: 59999
- do no load gconf plugin by default (#32251)

* Sat Aug 04 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.2-1mdv2008.0
+ Revision: 58860
- Update cube top image patch for 0.5.2
- Remove now default arguments from configure
- Do not run aclocal et al as this now breaks build
- Update to compiz 0.5.2

* Wed Aug 01 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.1-0.20070801.1mdv2008.0
+ Revision: 57834
- Updated snapshot

* Wed Jul 25 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.1-0.20070725.1mdv2008.0
+ Revision: 55249
- Update Snapshot

* Mon Jul 16 2007 Olivier Blin <oblin@mandriva.com> 0.5.1-0.20070712.2mdv2008.0
+ Revision: 52621
- add emerald support in compiz-window-decorator

* Sat Jul 14 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.1-0.20070712.1mdv2008.0
+ Revision: 52114
- Update snapshot

* Thu Jul 12 2007 Olivier Blin <oblin@mandriva.com> 0.5.1-0.20070707.4mdv2008.0
+ Revision: 51441
- make library package conflict with old compiz since a file has been moved (to ensure smooth upgrades)

* Sun Jul 08 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.1-0.20070707.3mdv2008.0
+ Revision: 49645
- Update default settings to load 'glib gconf'

* Sat Jul 07 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.1-0.20070707.2mdv2008.0
+ Revision: 49594
- Libify compiz and add more Requires to devel package

* Sat Jul 07 2007 Colin Guthrie <cguthrie@mandriva.org> 0.5.1-0.20070707.1mdv2008.0
+ Revision: 49555
- Require xslt packages in -devel package.
- Update Snapshot to 20070707

* Sat Jul 07 2007 Götz Waschk <waschk@mandriva.org> 0.5.1-0.20070627.1mdv2008.0
+ Revision: 49499
- fix buildrequires

  + Olivier Blin <oblin@mandriva.com>
    - buildrequires libxslt-devel

  + Colin Guthrie <cguthrie@mandriva.org>
    - Reenable all previous patches after rediffing
    - Update indirect-detection patch
    - Obsolete Beryl
    - Git snapshot from 20070627 to test new Fusion components.


* Sat Apr 07 2007 Olivier Blin <oblin@mandriva.com> 0.5.0-1mdv2007.1
+ Revision: 151022
- 0.5.0
- remove useless _COMPIZ_GL_INCLUDE_INFERIORS hack since cow is enabled by default in compiz nowadays
- remove merged restart support and kwd fixes
- enable fuse support

* Sun Mar 18 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-10mdv2007.1
+ Revision: 145718
- fix main schema installation (#29638)

* Fri Mar 16 2007 Laurent Montel <lmontel@mandriva.com> 0.3.6-9mdv2007.1
+ Revision: 144898
- Fix mem leak into kde-windows-decoration
  Add diff from 0.3.7 for kde-windows-decoration (fix crash, add shadow support)

* Thu Mar 15 2007 Frederic Crozat <fcrozat@mandriva.com> 0.3.6-8mdv2007.1
+ Revision: 144198
- Remove patch6 (no longer needed according to fedora)
- Fix Buildrequires : metacity decorations are back for gtk decorator

* Tue Mar 13 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-7mdv2007.1
+ Revision: 142163
- move gwd scheme in compiz-decorator-gtk (thanks to fcrozat)

* Sun Mar 11 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-6mdv2007.1
+ Revision: 141303
- add png to default plugins (thanks to mikala)

* Sun Mar 04 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-5mdv2007.1
+ Revision: 132156
- add compiz-window-decorator wrapper to auto-detect window decorator

* Sun Mar 04 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-4mdv2007.1
+ Revision: 132084
- move decorators in compiz-decorator-gtk and compiz-decorator-kde (#29122)

* Fri Mar 02 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-3mdv2007.1
+ Revision: 131577
- buildrequires libdbus-qt-1-devel
- buildrequires kdebase-devel
- buildrequires kdelibs-devel after all
- buildrequires kdecore-devel
- fix qt library path for x86_64 in configure script
- enable kde-window-decorator

* Fri Feb 09 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-2mdv2007.1
+ Revision: 118642
- allow session manager to restart compiz if it crashes (from RH)
- add patch from gandalfn to workaround white boder shadows with AIGLX
- add GConf2 post/preun requires

* Mon Jan 01 2007 Olivier Blin <oblin@mandriva.com> 0.3.6-1mdv2007.1
+ Revision: 103015
- 0.3.6
- revert upstream indirect rendering detection patch, it seems to require LIBGL_ALWAYS_INDIRECT

* Wed Dec 20 2006 Olivier Blin <oblin@mandriva.com> 0.3.4-2mdv2007.1
+ Revision: 100538
- activate all plugins by default

* Wed Nov 22 2006 Olivier Blin <oblin@mandriva.com> 0.3.4-1mdv2007.1
+ Revision: 86415
- 0.3.4

* Wed Nov 15 2006 Olivier Blin <oblin@mandriva.com> 0.3.2-4mdv2007.1
+ Revision: 84229
- new release
- use find_lang macro
- add compiz.defaults file

* Tue Nov 14 2006 Olivier Blin <oblin@mandriva.com> 0.3.2-3mdv2007.1
+ Revision: 84205
- make the devel package require GL-devel

* Mon Nov 13 2006 Olivier Blin <oblin@mandriva.com> 0.3.2-2mdv2007.1
+ Revision: 83931
- add missing requires in the devel package
- simplify schemas installation
- remove unneeded configure flags
- update URL

* Mon Nov 13 2006 Olivier Blin <oblin@mandriva.com> 0.3.2-1mdv2007.1
+ Revision: 83716
- add gwd schemas
- 0.3.2

* Sun Oct 15 2006 Olivier Blin <oblin@mandriva.com> 0.2.0-1mdv2006.0
+ Revision: 65130
- cosmetics and own some dirs
- 0.2.0
- move common compositing wm scripts/images in compositing-wm-common (configuration file is not backward compatible)
- provide compositing-wm

* Fri Sep 15 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.11mdv2007.0
+ Revision: 61400
- fix LD_LIBRARY_PATH in compiz-start (#25439)

* Thu Sep 14 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.10mdv2007.0
+ Revision: 61345
- increase release (thanks to Colin Guthrie for all the help on #25429)
- use KDEWM to run compiz-start in KDE (#25429)
- use WINDOW_MANAGER to run compiz-start in Gnome (#25429)
- pass positionnal parameters from compiz-start to compiz
- move compiz/decorator actual start in compiz-start

* Fri Sep 08 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.9mdv2007.0
+ Revision: 60563
- use _libdir/mesa as LD_LIBRARY_PATH for compiz if Xgl is running

  + Antonio Hobmeir Neto <neto@mandriva.com>
    - + This is a provisory solution to fix a bug.
      - minimize and unminimize quickly one window, the window lost your original position.

* Wed Aug 30 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.7mdv2007.0
+ Revision: 58573
- add some useful patches from  Fedora

* Sat Aug 26 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.6mdv2007.0
+ Revision: 58062
- use new top image, and adapt schema to scale image

* Fri Aug 25 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.5mdv2007.0
+ Revision: 57988
- really make the sysconfig file a config file
- simplify compiz args handling
- allow to configure another window decorator (#24620)
- remove hardcoded compiz and window-decorator path
- don't start compiz if in failsafe or drak3d session
- disable compiz by default
- start compiz after dbus in xinit

  + vguardiola <vguardiola>
    - New image top of cube
    - Change top image

* Tue Aug 22 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.4mdv2007.0
+ Revision: 56904
- compiz-0.0.13-0.20060817.4mdv2007.0
- handle the no3ddesktop cmdline option
- require mesa-demos

* Sat Aug 19 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.3mdv2007.0
+ Revision: 56750
- sleep some seconds to prevent kwin from stealing the display
- auto-start compiz if possible
- compiz-0.0.13-0.20060817.3mdv2007.0
- automatically enable indirectRendering and strictBinding on AIGLX

* Fri Aug 18 2006 Olivier Blin <oblin@mandriva.com> 0.0.13-0.20060817.2mdv2007.0
+ Revision: 56610
- 0.0.13-0.20060817.2mdv2007.0
- require COMPIZ to be explicitely set to 'yes' in sysconfig file
- use --indirect-rendering --strict-binding by in xinit script when Xgl isn't used
- split long description
- add compiz-mandriva.png.patch and drop compiz-mdv.schemas
- drop duplicated schema, better patch compiz to use mandriva.png as default image
- remove old source

* Fri Aug 18 2006 Sébastien Savarin <plouf@mandriva.org> 0.0.13-0.20060817.1mdv2007.0
+ Revision: 56560
- Add forgotten sources
-add compiz-mdv.schemas and mandriva.png

* Fri Aug 11 2006 Olivier Blin <oblin@mandriva.com> 0.0.12.98-5mdv2007.0
+ Revision: 55441
- bump release
- really install sysconfig file
- fix the "don't run configure twice" hack
- allow to start compiz in X session (config in /etc/sysconfig/compiz)
- don't run configure twice

  + Christiaan Welvaart <spturtle@mandriva.org>
    - add BuildRequires: libxcomposite-devel libxdamage-devel intltool

  + Thierry Vignaud <tvignaud@mandriva.com>
    - release
    - fix buildrequires for x86_64

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - Fixed some typos
    - Added the options for AIGLX in the description
    - Adding compiz to the repository
    - Adding patches making it work when using AIGLX

  + Frederic Crozat <fcrozat@mandriva.com>
    - Add registration of gconf schema

